///////////////////////////////////////////////
///////////////////////////////////////////////
/////                                     /////
/////     hinge eqatorial mount           /////
/////     controler program  ver.8        /////
/////     for  pic 16f873 - 20MHz         /////
/////                                     /////
/////     rb4-rb7 stepper motor control   /////
/////     rc5     START    button         /////
/////     rc4     FORWARD  button         /////
/////     rc3     BACKWARD button         /////
/////     rc2     rotational direction SW /////
/////     ra0     indicator(LED)          /////
/////     ra1     buzzer                  /////
/////                                     /////
/////     create 2006.09.21               /////
/////                                     /////
///////////////////////////////////////////////
///////////////////////////////////////////////


#include	<16f873.h>
#include	<math2.h>
							//sin֐main֐ɃCCWJĂ邱
							//ɂout of rom΍ƂāAmath.h
							//gɑ΂#separatesin֐CCWJ
							//Ȃ悤ɕύXmath2.h쐬ĎgpB

#fuses	HS,NOWDT,NOPROTECT,PUT
#use	delay(CLOCK = 20000000)
#use	fast_io(A)
#use	fast_io(B)
#use	fast_io(C)


/////     global variable declare

static	int32	lCounter;	//oߎԁ~POOi0.01bincj

static	char	cPattern[4][2] = {{0b00010000,0b00010000},
		                  {0b00100000,0b10000000},
		                  {0b01000000,0b01000000},
		                  {0b10000000,0b00100000}};	//XebsO[^[쓮p^[



/////     interrupt  process

#int_ccp1					//bboP̊荞ݏ

void	ccp1_isr()
{
	lCounter++;	
}


/////     initial set up process

#separate

init_setup()
{
	/*@`cbsgp@*/

	setup_adc_ports(NO_ANALOGS);
	setup_adc(ADC_OFF);			//ADC OFF


	/*@o͐ݒ@*/

	set_tris_a(0b00000000);			//ra0-ra1  for output
	set_tris_b(0b00000000);			//rb4-rb7  for output
	set_tris_c(0b00111100);			//rc2-rc5  for input


	/*@^C}PvXP[WœNbN@*/

	setup_timer_1(T1_INTERNAL | T1_DIV_BY_8);


	/*@bboP@RyAvŃ^C}PZbg@*/


	setup_ccp1(CCP_COMPARE_RESET_TIMER);

	CCP_1 = 6250;				//0.2us(20Mhz1TCN쎞)~8{~6250 = 0.01b
	set_timer1(0);				//^C}PZbg


	/*@Ӌ@グԊmہ@*/

	delay_ms(1000);
}


/////     calculate

			////////////////
			//_ľvZ//
			////////////////
			/*@M4lW & a145.00mm & 1]30(=48*25/40)Xebv̏ꍇ@*/
			//fWork = 145.0 * sin(2.0 * PI * ( (float)lCntref / 100.0 + 5137.05) / 2.0 / 86164.0) * 2.0 * 200.0 *60.0 * 60.0 / 16.0 / 54.0 / 0.7;

#separate

float	calc(int32 lCn)
{
	float	fWk;
	
	fWk = sin(((float)lCn / 100.0 + 5137.05) / 27426.85) * 345238.1;
	return	fWk;
}


/////     buzz

#separate

buzz(long lR)
{
	if ( (lR >= 0    && lR <= 10  ) ||
		 (lR >= 40   && lR <= 50  ) ||
		 (lR >= 3000 && lR <= 3010)   )
	{
		output_bit(PIN_A1,1);		//uU[
	}
	else {
		output_bit(PIN_A1,0);		//uU[
	}
}


/////     led lights every second

led_light(long lR2)
{
	if ( lR2 >= 0    && lR2 <= 50  )
	{
		output_bit(PIN_A0,1);		//kdc_
	}
	else {
		output_bit(PIN_A0,0);		//kdc
	}
}




/////     main loop


void	main()
{

	//////////////////////
	//@@@@//
	//////////////////////

	/*@ϐ`@*/

	int32	lLoop;				//[vpJE^

	int32	lTheoreticalvalue;		//_l(32bit)@coߎԂɂXebv
	int32	lAccumulativevalue;		//ݐϒl(32bit)@cт̗ݐσXebv

	float	fWork;				//vZp̃[Nϐ

	int	iPattern;			//p^[ԍiO`Rj
	int	iDirection;			//]iPFbbvAOFbvj

	long	lRemainder;			//JE^[lUOOOŊ]
	long	lRemainder2;			//JE^[lPOOŊ]

	int32	lCntref;			//lCountermain֐QƗpϐi荞݃^C~Olj


	init_setup();


	/*@]̓͂Ƌ쓮p^[̏ݒ@*/

	iPattern = 0;				//p^[ԍ̏lO
	iDirection = input(PIN_C2);		//]̓́id1񂾂`FbNj


	/*@オ胁bZ[W@*/

	for (lLoop=0;lLoop<3;lLoop++) {
		output_bit(PIN_A0,1);		//kdc_
		output_bit(PIN_A1,1);		//uU[
		delay_ms(200);

		output_bit(PIN_A0,0);		//kdc
		output_bit(PIN_A1,0);		//uU[
		delay_ms(200);
	}


	////////////////////////
	//@@C[v@@//
	////////////////////////

	while(1)				//[v
	{

		lAccumulativevalue = 64286;	//ݐϒlNA
		lCounter = 0;			//JE^i荞݉񐔁jlO
		lCntref = 0;			//mainQƗpJE^lO

		////////////////////////////////
		//@@px̐ݒ胂[h@@//
		////////////////////////////////

		output_bit(PIN_A0,0);		//kdc
		output_bit(PIN_A1,0);		//uU[

		while ( input(PIN_C5) == 1 ) {	//START܂

			if( input(PIN_C4) == 0 ) {
				iPattern++;
				if (iPattern == 4) {
					iPattern = 0;
				}
			}

			if( input(PIN_C3) == 0 ) {
				iPattern--;
				if (iPattern == -1) {
					iPattern = 3;
				}
			}

			output_b(cPattern[iPattern][iDirection]);

			delay_ms(5);		//5ms~833Xebv4.2b/P
		}

		output_bit(PIN_A1,1);		//uU[

		while ( input(PIN_C5) == 0 ) {  //START𗣂܂ő҂
		}

		output_bit(PIN_A0,1);		//kdc_
		output_bit(PIN_A1,0);		//uU[


		//////////////////////////////////
		//@@[^[ǔ샂[h@@//
		//////////////////////////////////

		enable_interrupts(INT_CCP1);
		enable_interrupts(GLOBAL);

		while (lCntref <= 720000) {			//2ԃ[v

			lRemainder = (long)(lCntref % 6000);	//JE^UOOOŊ]
			                                //  6000 = 1  荞ݕpx0.01b

			lRemainder2 = (long)(lCntref % 100);	//JE^POOŊ]
			                                //  100 = 1b  荞ݕpx0.01b
			
			////////////////////////////////////////////////
			//@@傤ǂPƊeRObbeep@@//
			////////////////////////////////////////////////
			
			buzz(lRemainder);


			////////////////////////////////////////
			//@@PbƂɂkdc_ł@@//
			////////////////////////////////////////
			
			led_light(lRemainder2);


			////////////////
			//_ľvZ//
			////////////////
			fWork = calc(lCntref);			//JE^l痝_̃XebvZo
			lTheoreticalvalue = (int32) fWork;

			if (lAccumulativevalue < lTheoreticalvalue) {



				//////////////////////////////////////
				//_l̕傫ђl@//
				//JEgAbvāArbgp^[//
				//Pi߂B@@@@@@@@@@//
				//////////////////////////////////////

				lAccumulativevalue++;

				iPattern++;
				if (iPattern == 4) {
					iPattern = 0;
				}

				output_b(cPattern[iPattern][iDirection]);
			}

			if ( input(PIN_C3) ==0 ) {
				break;		//BACKWARDŋ߂
			}

			/*@Ɗݏ̃obeBOz肵@*/
			/*@͔rɊ݂obeBO蒼@*/
			do {
				lCntref = lCounter;
			} while (lCntref != lCounter);

		}


		////////////////////////////////
		//@@ǔȈ[h@//
		////////////////////////////////

		disable_interrupts(GLOBAL);

		output_bit(PIN_A0,0);		//kdc


		/*@߂ȊȌꍇ̓uU[2Ԍo߂AiEX@*/

		if (lCntref >= 720000) {	//JE^i7200b0.01bjo߁H

			/*@2Ԍoߎ̃AiEX@*/

			for (lLoop=0;lLoop<5;lLoop++) {

				output_bit(PIN_A0,1);		//kdc_
				output_bit(PIN_A1,1);		//uU[
				delay_ms(600);

				output_bit(PIN_A0,0);		//kdc
				output_bit(PIN_A1,0);		//uU[
				delay_ms(100);
			}

			/*@BACKWARD܂Ł@*/
			while ( input(PIN_C3) ==1 ) {
			}

		}
		else {

			/*@2ԌoߑOɋ߂̏ꍇ̃AiEX@*/

			output_bit(PIN_A0,1);		//kdc_
			output_bit(PIN_A1,1);		//uU[
			delay_ms(600);
			output_bit(PIN_A0,0);		//kdc
			output_bit(PIN_A1,0);		//uU[
		}

		/*@BACKWARD𗣂܂Ł@*/
		while ( input(PIN_C3) ==0 ) {
		}

		////////////////////////
		//@@߂@@//
		////////////////////////

		output_bit(PIN_A0,1);		//kdc_

		for (lLoop=lAccumulativevalue;lLoop>64286;lLoop--) {
			iPattern--;
			if (iPattern == -1) {
				iPattern = 3;
			}
			output_b(cPattern[iPattern][iDirection]);

			delay_ms(5);		//S߂:5ms~(150110-64286)steps429b(7.2)
		}

		output_bit(PIN_A0,0);		//kdc

		for (lLoop=0;lLoop<4;lLoop++) {
			output_bit(PIN_A1,1);		//uU[
			delay_ms(100);
			output_bit(PIN_A1,0);		//uU[
			delay_ms(300);
		}

		set_timer1(0);			//^C}PZbg

	}
}


